 /* 

/// Brad and Mike Function:  PlusDI

  // calculated just like the ATR (only using DM_Plus instead of TrueRange)
*/

#include <string.h>
#include <float.h>
#include <math.h>
#include <limits.h>
#include <stdlib.h>

#include "MSXSafetyChecks.h"
#include "MSXStruc.h"
#include "Adaptive.h"

void DM_Minus (const MSXDataRec * MasterData,
			MSXDataInfoRec * Result)
{
	int startIdx = MasterData->sClose.iFirstValid;
	int endIdx = MasterData->sClose.iLastValid;

	// First Element is undefined, but it is set to zero here in case we are not truncating
	Result->pfValue[startIdx] = 0.0;
	// reverse the loop so we don't have to use a temp array
	for (int i = endIdx; i >= startIdx + 1; i--)
	{
		Result->pfValue[i] = (float)ForceFloatRange(
			MSX_DM_Minus(
				MasterData->sHigh.pfValue[i-1],
				MasterData->sLow.pfValue[i-1],
				MasterData->sHigh.pfValue[i],
				MasterData->sLow.pfValue[i])	
			);	
	}	

	Result->iFirstValid = startIdx;
	Result->iLastValid = endIdx;
}