 /* 

/// Brad and Mike Function:  PlusDI

  // calculated just like the ATR (only using DM_Plus instead of TrueRange)
*/

#include <string.h>
#include <float.h>
#include <math.h>
#include <limits.h>
#include <stdlib.h>

#include "MSXSafetyChecks.h"
#include "MSXStruc.h"
#include "Adaptive.h"

void PDI (const MSXDataRec * MasterData, const MSXDataInfoRec * Periods, 
			MSXDataInfoRec * Result)
{
	// Stores a temporary Result from a Call to the EMA function,
	MSXDataInfoRec Temp;

	// Return an invalid array if we cannot allocate memory on the heap for the Temp array.
	if (! MSX_ARRAY_ALLOC(MasterData, &Temp) )
	{
		Result->iFirstValid = 0; 
		Result->iLastValid = 0;
		return;
	}

	DM_Plus(MasterData, &Temp);
	
	SMA(&Temp, Periods, Result);

	int startIdx = Result->iFirstValid;
	int endIdx = Result->iLastValid;

	//Result->pfValue[startIdx] = 1.8625;

	for (int i = startIdx; i <= endIdx; i++)
	{
		// we are assuming good period behavior in the beginning...
		int period = int(ForceIntRange(Periods->pfValue[i]));
		
		if(period < 1) 
			period = 1;

		Result->pfValue[i] = (float)ForceFloatRange( 
							( Result->pfValue[i-1] * (period-1) + Temp.pfValue[i] ) / period
							); 
	}

	// Don't Forget to DeAllocate Array
	MSX_ARRAY_DEALLOC(&Temp);

}

/*
	MSXDataInfoRec Temp;
	if (! MSX_ARRAY_ALLOC(MasterData, &Temp) )
	{
		Result->iFirstValid = 0; 
		Result->iLastValid = 0;
		return;
	}

	DM_Plus(MasterData, &Temp);
	
	SMA(&Temp, Periods, Result);

	int startIdx = Result->iFirstValid;
	int endIdx = Result->iLastValid;

	for (int i = startIdx; i <= endIdx; i++)
	{
		// we are assuming good period behavior in the beginning...
		int period = int(ForceIntRange(Periods->pfValue[i]));
		
		if(period < 1) 
			period = 1;

	
		Result->pfValue[0] = (float)ForceFloatRange( 
							( Result->pfValue[i-1] * (period-1) + Temp.pfValue[i] ) / period
							);
	}

	MSX_ARRAY_DEALLOC(&Temp);
	MSXDataInfoRec Temp2;
	if (! MSX_ARRAY_ALLOC(MasterData, &Temp2) )
	{
		Result->iFirstValid = 0; 
		Result->iLastValid = 0;
		return;
	}

	
	ATR(MasterData, Periods, &Temp2);

	for (i = startIdx; i <= endIdx; i++)
	{

		if (!IsDoubleZero(Temp2.pfValue[i]))
			Result->pfValue[i] = (float)ForceFloatRange( Result->pfValue[i] / Temp.pfValue[i] * 100);
	}


	MSX_ARRAY_DEALLOC(&Temp2);

}
*/
