 /* 

/// Brad and Mike Function:  TrueRange

  // Just a simple function, not adaptive.
*/

#include <string.h>
#include <float.h>
#include <math.h>
#include <limits.h>
#include <stdlib.h>

#include "MSXSafetyChecks.h"
#include "MSXStruc.h"
#include "Adaptive.h"

void TrueRange (const MSXDataRec * MasterData, 
			MSXDataInfoRec * Result)
{
	int startIdx = MasterData->sClose.iFirstValid;
	int endIdx = MasterData->sClose.iLastValid;

	double TodayLow;
	double TodayHigh;
	double YesClose;

	// First Element is undefined, but it is set to zero here in case we are not truncating
	Result->pfValue[startIdx] = 0.0;
	for (int i = startIdx + 1; i <= endIdx; i++)
	{
		TodayLow = MasterData->sLow.pfValue[i];
		TodayHigh = MasterData->sHigh.pfValue[i];
		YesClose = MasterData->sClose.pfValue[i - 1];
		Result->pfValue[i] = (float)ForceFloatRange(
			MSX_TrueRange(TodayLow, TodayHigh, YesClose));	
	}	

	Result->iFirstValid = startIdx;
	Result->iLastValid = endIdx;
}
