/*

DML BSD License

  /* The Dynamic Market Lab, LLC Copyright (c) 2004-2005,
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or
 * without modification, are permitted provided that the following
 * conditions are met:
 *
 * - Redistributions of source code must retain the above copyright
 *   notice, this list of conditions and the following disclaimer.
 *
 * - Redistributions in binary form must reproduce the above copyright
 *   notice, this list of conditions and the following disclaimer in
 *   the documentation and/or other materials provided with the
 *   distribution.
 *
 * - Neither name of author nor the names of its contributors
 *   may be used to endorse or promote products derived from this
 *   software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * REGENTS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE
 * OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
 * EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

*/

// The Code below is Adapted from the Metastock Developers Kit Manual


// this is necessary for DllMain and windows functions.
#include <windows.h>

#include <string.h>
#include <float.h>
#include <math.h>
#include <limits.h>
#include <stdlib.h>

#include "MSXStruc.h"

#include "license.h"


// we don't want C++ name-mangling
#ifdef __cplusplus
extern "C" {
#endif

	//------------------------------------------------------------------------
// DLLMain
//
// This function is called when MetaStock (or MSXTest) loads and unloads
//   this DLL.  Global variable initialization, memory allocation, or
//   other initialization can be placed here.
// The return value (l_bRtrn) is used only when the function is called
//   with DLL_PROCESS_ATTACH, otherwise it is ignored.  See your Windows
//   programming documentation for more information regarding DllMain.
//------------------------------------------------------------------------
	
BOOL WINAPI DllMain( HANDLE a_hModule, 
                     DWORD  a_fdwReason, 
                     LPVOID a_lpReserved
				   )
{
	const int typeASI = 0;
	int ret;

	Login login;

	switch (a_fdwReason)
	{
	case DLL_PROCESS_ATTACH:
		// Code placed here will execute when the DLL is first loaded by MetaStock (or MSXTest).
		// If your DLL requires initialization of global variables or other start-up
		//   processing, do that here.

  	/*
		ret = login.IsLoginSuccessful(typeASI);

		if (ret == 0)
		{
			//MessageBoxA(NULL, "Successful License Check", "The DML", MB_OK);
			return TRUE;
		}
		else
		{
			char str[10];
			itoa(ret, str, 10);
			str[10] = '\0';

			MessageBoxA(NULL, "Your DML Trial Initialization has expired", "The DML", MB_OK);
			//ShellExecute(NULL,"open", "http://www.thedml.com/expired", "", "c:\\", SW_SHOWNORMAL);
			return FALSE;
		}
*/
		return TRUE;

		break;

	case DLL_PROCESS_DETACH:

		return TRUE;
		// Code placed here will execute when the DLL is unloaded by MetaStock (or MSXTest).
		// If you allocated memory in DLL_PROCESS_ATTACH, deallocate it here.
		break;
	default:
		return FALSE;
		break;
	}
}


//------------------------------------------------------------------------
BOOL __stdcall MSXInfo (MSXDLLDef *a_psDLLDef)
{
strncpy (a_psDLLDef->szCopyright, "Adaptive Standard Indicators (ASI) - Copyright  The Dynamic Market Lab, LLC. www.thedml.com",
sizeof(a_psDLLDef->szCopyright)-1);
a_psDLLDef->iNFuncs = 35; // number of functions being exported
a_psDLLDef->iVersion = MSX_VERSION;
return MSX_SUCCESS;
}

BOOL __stdcall MSXNthCustomString ( int a_iNthFunc, int a_iNthArg, int a_iNthString,
								   MSXFuncCustomString * a_psCustomString)
{
	BOOL ret = MSX_SUCCESS;

	return ret;
/*
	typedef struct
	{
		char *szString;
		int iID;
	} 
	LocalStringElement;

	LocalStringElement MovElements[] =
	{
		{"Simple", 0}, {"Exp", 1}, {"Weighted", 2},
		{"S", 0}, {"E", 1}, {"W", 2}
	};
	
	LocalStringElement ROCElements[] =
	{
		{"Percent", 0}, {"Absolute", 1},
		{"%", 0}, {"$", 1}
	};


	switch (a_iNthFunc)
	{
		case 24:
			switch (a_iNthArg)
			{
				case 2:
					if (a_iNthString >= 0 && a_iNthString < 1) // 1 = # of custom strings for this func.
					{
						strncpy (a_psCustomString->szString, 
								MovElements[a_iNthString].szString, 
								MSX_MAXSTRING-1);
						
						a_psCustomString->iID = MovElements[a_iNthString].iID;
					}
					break;
					
				default:
					ret = MSX_ERROR;
					break;
			}
			break;

		case 32:
			switch (a_iNthArg)
			{
				case 2:
					if (a_iNthString >= 0 && a_iNthString < 1) // 1 = # of custom strings for this func.
					{
						strncpy (a_psCustomString->szString, 
								ROCElements[a_iNthString].szString, 
								MSX_MAXSTRING-1);
						
						a_psCustomString->iID = ROCElements[a_iNthString].iID;
					}
					break;
					
				default:
					ret = MSX_ERROR;
					break;
			}
			break;

		default:
			ret = MSX_ERROR;
			break;
	}

	return ret;

  */
}


//------------------------------------------------------------------------
BOOL __stdcall MSXNthFunction (int a_iNthFunc, MSXFuncDef *a_psFuncDef)
{
	BOOL l_bRtrn = MSX_SUCCESS; // no error

	switch (a_iNthFunc)
	{

		case 0:
			strcpy (a_psFuncDef->szFunctionName, "AroonDown");
			strcpy (a_psFuncDef->szFunctionDescription, "Aroon Down");
			a_psFuncDef->iNArguments = 2;
			break;
		case 1:
			strcpy (a_psFuncDef->szFunctionName, "AroonUp");
			strcpy (a_psFuncDef->szFunctionDescription, "Aroon Up");
			a_psFuncDef->iNArguments = 2;
			break;
		case 2:
			strcpy (a_psFuncDef->szFunctionName, "BBandBot");
			strcpy (a_psFuncDef->szFunctionDescription, "Bollinger Band Bottom");
			a_psFuncDef->iNArguments = 3;
			break;
		case 3:
			strcpy (a_psFuncDef->szFunctionName, "BBandTop");
			strcpy (a_psFuncDef->szFunctionDescription, "Bollinger Band Top");
			a_psFuncDef->iNArguments = 3;
			break;
		case 4:
			strcpy (a_psFuncDef->szFunctionName, "CCI");
			strcpy (a_psFuncDef->szFunctionDescription, "Commodity Channel Index (Standard)");
			a_psFuncDef->iNArguments = 1;
			break;
		case 5:
			strcpy (a_psFuncDef->szFunctionName, "Correl");
			strcpy (a_psFuncDef->szFunctionDescription, "Correlation Analysis");
			a_psFuncDef->iNArguments = 3;
			break;
		case 6:
			strcpy (a_psFuncDef->szFunctionName, "DEMA");
			strcpy (a_psFuncDef->szFunctionDescription, "Double Exponential Moving Average");
			a_psFuncDef->iNArguments = 2;
			break;
		case 7:
			strcpy (a_psFuncDef->szFunctionName, "EMA");
			strcpy (a_psFuncDef->szFunctionDescription, "Exponential Moving Average");
			a_psFuncDef->iNArguments = 2;
			break;
		case 8:
			strcpy (a_psFuncDef->szFunctionName, "HHV");
			strcpy (a_psFuncDef->szFunctionDescription, "Highest High Value");
			a_psFuncDef->iNArguments = 2;
			break;
		case 9:
			strcpy (a_psFuncDef->szFunctionName, "HHVBarsAgo");
			strcpy (a_psFuncDef->szFunctionDescription, "HHV Bars Ago");
			a_psFuncDef->iNArguments = 2;
			break;
		case 10:
			strcpy (a_psFuncDef->szFunctionName, "LinearReg");
			strcpy (a_psFuncDef->szFunctionDescription, "Linear Regression Indicator");
			a_psFuncDef->iNArguments = 2;
			break;
		case 11:
			strcpy (a_psFuncDef->szFunctionName, "LinearRegSlope");
			strcpy (a_psFuncDef->szFunctionDescription, "Linear Regression Slope");
			a_psFuncDef->iNArguments = 2;
			break;
		case 12:
			strcpy (a_psFuncDef->szFunctionName, "LLV");
			strcpy (a_psFuncDef->szFunctionDescription, "Lowest Low Value");
			a_psFuncDef->iNArguments = 2;
			break;
		case 13:
			strcpy (a_psFuncDef->szFunctionName, "LLVBarsAgo");
			strcpy (a_psFuncDef->szFunctionDescription, "LLV Bars Ago");
			a_psFuncDef->iNArguments = 2;
			break;
		case 14:
			strcpy (a_psFuncDef->szFunctionName, "MACD");
			strcpy (a_psFuncDef->szFunctionDescription, "Moving Average Convergence/Divergence (Price Oscillator)");
			a_psFuncDef->iNArguments = 3;
			break;
		case 15:
			strcpy (a_psFuncDef->szFunctionName, "Mid");
			strcpy (a_psFuncDef->szFunctionDescription, "Midpoint");
			a_psFuncDef->iNArguments = 2;
			break;
		case 16:
			strcpy (a_psFuncDef->szFunctionName, "Mo");
			strcpy (a_psFuncDef->szFunctionDescription, "Momentum");
			a_psFuncDef->iNArguments = 2;
			break;
		case 17:
			strcpy (a_psFuncDef->szFunctionName, "PriceChannelHigh");
			strcpy (a_psFuncDef->szFunctionDescription, "Price Channel High");
			a_psFuncDef->iNArguments = 2;
			break;
		case 18:
			strcpy (a_psFuncDef->szFunctionName, "PriceChannelLow");
			strcpy (a_psFuncDef->szFunctionDescription, "Price Channel Low");
			a_psFuncDef->iNArguments = 2;
			break;
		case 19:
			strcpy (a_psFuncDef->szFunctionName, "RSquared");
			strcpy (a_psFuncDef->szFunctionDescription, "r squared");
			a_psFuncDef->iNArguments = 2;
			break;
		case 20:
			strcpy (a_psFuncDef->szFunctionName, "ROC");
			strcpy (a_psFuncDef->szFunctionDescription, "Rate of Change");
			a_psFuncDef->iNArguments = 3;
			break;
		case 21:
			strcpy (a_psFuncDef->szFunctionName, "Ref");
			strcpy (a_psFuncDef->szFunctionDescription, "Reference");
			a_psFuncDef->iNArguments = 2;
			break;
		case 22:
			strcpy (a_psFuncDef->szFunctionName, "RefWrite");
			strcpy (a_psFuncDef->szFunctionDescription, "Write to a Ref() Location (assignment)");
			a_psFuncDef->iNArguments = 4;
			break;
		case 23:
			strcpy (a_psFuncDef->szFunctionName, "RMI");
			strcpy (a_psFuncDef->szFunctionDescription, "Relative Momentum Index");
			a_psFuncDef->iNArguments = 3;
			break;
		case 24:
			strcpy (a_psFuncDef->szFunctionName, "RSI");
			strcpy (a_psFuncDef->szFunctionDescription, "Relative Strength Index (RSI)");
			a_psFuncDef->iNArguments = 2;
			break;
		case 25:
			strcpy (a_psFuncDef->szFunctionName, "RVGI");
			strcpy (a_psFuncDef->szFunctionDescription, "Relative Vigor Index");
			a_psFuncDef->iNArguments = 2;
			break;
		case 26:
			strcpy (a_psFuncDef->szFunctionName, "SMA");
			strcpy (a_psFuncDef->szFunctionDescription, "Simple Moving Average");
			a_psFuncDef->iNArguments = 2;
			break;
		case 27:
			strcpy (a_psFuncDef->szFunctionName, "Stdev");
			strcpy (a_psFuncDef->szFunctionDescription, "Standard Deviation");
			a_psFuncDef->iNArguments = 3;
			break;
		case 28:
			strcpy (a_psFuncDef->szFunctionName, "Stoch");
			strcpy (a_psFuncDef->szFunctionDescription, "Stochastic Oscillator");
			a_psFuncDef->iNArguments = 1;
			break;
		case 29:
			strcpy (a_psFuncDef->szFunctionName, "Sum");
			strcpy (a_psFuncDef->szFunctionDescription, "Summation");
			a_psFuncDef->iNArguments = 2;
			break;
		case 30:
			strcpy (a_psFuncDef->szFunctionName, "Tema");
			strcpy (a_psFuncDef->szFunctionDescription, "Tema");
			a_psFuncDef->iNArguments = 2;
			break;
		case 31:
			strcpy (a_psFuncDef->szFunctionName, "TSF");
			strcpy (a_psFuncDef->szFunctionDescription, "Time Series Forecast");
			a_psFuncDef->iNArguments = 2;
			break;
		case 32:
			strcpy (a_psFuncDef->szFunctionName, "TRIX");
			strcpy (a_psFuncDef->szFunctionDescription, "TRIX");
			a_psFuncDef->iNArguments = 2;
			break;	
		case 33:
			strcpy (a_psFuncDef->szFunctionName, "VAR");
			strcpy (a_psFuncDef->szFunctionDescription, "Variance");
			a_psFuncDef->iNArguments = 2;
			break;
		case 34:
			strcpy (a_psFuncDef->szFunctionName, "WMA");
			strcpy (a_psFuncDef->szFunctionDescription, "Weighted Moving Average");
			a_psFuncDef->iNArguments = 2;
			break;
		default:
			l_bRtrn = MSX_ERROR; // This will help MSXTest find errors in your code
			break;
	}
	return l_bRtrn;
}

// ---------------------------------------------------------------------------------

//-----------------------------------------------------------------------------------

BOOL __stdcall MSXNthArg (int a_iNthFunc, int a_iNthArg,
                         MSXFuncArgDef *a_psFuncArgDef)
{
	BOOL l_bRtrn = MSX_SUCCESS;

	a_psFuncArgDef->iNCustomStrings = 0; // init just to be nice

	switch (a_iNthFunc)
	{

		case 0: // Aroon Down
			
			switch (a_iNthArg)
			{
				case 0: // Data Array
					a_psFuncArgDef->iArgType = MSXDataArray;
					strcpy (a_psFuncArgDef->szArgName, "Data Array");
					break;
				case 1: // Periods
					a_psFuncArgDef->iArgType = MSXDataArray;
					strcpy (a_psFuncArgDef->szArgName, "Periods");
					break;
				default:
					l_bRtrn = MSX_ERROR; // This will help MSXTest find errors in your code
					break;
			}
			break;	
		
		case 1: // Aroon Up
			
			switch (a_iNthArg)
			{
				case 0: // Data Array
					a_psFuncArgDef->iArgType = MSXDataArray;
					strcpy (a_psFuncArgDef->szArgName, "Data Array");
					break;
				case 1: // Periods
					a_psFuncArgDef->iArgType = MSXDataArray;
					strcpy (a_psFuncArgDef->szArgName, "Periods");
					break;
				default:
					l_bRtrn = MSX_ERROR; // This will help MSXTest find errors in your code
					break;
			}
			break;
		
		case 2: // BBandBot
			
			switch (a_iNthArg)
			{
				case 0: // Data Array
					a_psFuncArgDef->iArgType = MSXDataArray;
					strcpy (a_psFuncArgDef->szArgName, "Data Array");
					break;
				case 1: // Periods
					a_psFuncArgDef->iArgType = MSXDataArray;
					strcpy (a_psFuncArgDef->szArgName, "Periods");
					break;
				case 2: // deviations
					a_psFuncArgDef->iArgType = MSXNumeric;
					strcpy (a_psFuncArgDef->szArgName, "deviations");
					break;
				default:
					l_bRtrn = MSX_ERROR; // This will help MSXTest find errors in your code
					break;
			}
			break;

		case 3: // BBandTop
			
			switch (a_iNthArg)
			{
				case 0: // Data Array
					a_psFuncArgDef->iArgType = MSXDataArray;
					strcpy (a_psFuncArgDef->szArgName, "Data Array");
					break;
				case 1: // Periods
					a_psFuncArgDef->iArgType = MSXDataArray;
					strcpy (a_psFuncArgDef->szArgName, "Periods");
					break;
				case 2: // deviations
					a_psFuncArgDef->iArgType = MSXNumeric;
					strcpy (a_psFuncArgDef->szArgName, "deviations");
					break;
				default:
					l_bRtrn = MSX_ERROR; // This will help MSXTest find errors in your code
					break;
			}
			break;

		case 4: // CCI (Periods)
			
			switch (a_iNthArg)
			{
				case 0: // Periods
					a_psFuncArgDef->iArgType = MSXDataArray; 
					strcpy (a_psFuncArgDef->szArgName, "Periods");
					break;
				default:
					l_bRtrn = MSX_ERROR; // This will help MSXTest find errors in your code
					break;
			}
			break;

		case 5: // Correl
			
			switch (a_iNthArg)
			{
				case 0: // Data Array
					a_psFuncArgDef->iArgType = MSXDataArray;
					strcpy (a_psFuncArgDef->szArgName, "INDEPENDENT Array");
					break;
				case 1: // Periods
					a_psFuncArgDef->iArgType = MSXDataArray;
					strcpy (a_psFuncArgDef->szArgName, "DEPENDENT Array");
					break;
				case 2: // deviations
					a_psFuncArgDef->iArgType = MSXDataArray;
					strcpy (a_psFuncArgDef->szArgName, "Periods");
					break;
				default:
					l_bRtrn = MSX_ERROR; // This will help MSXTest find errors in your code
					break;
			}
			break;

		case 6: // DEMA
			
			switch (a_iNthArg)
			{
				case 0: // Data Array
					a_psFuncArgDef->iArgType = MSXDataArray;
					strcpy (a_psFuncArgDef->szArgName, "Data Array");
					break;
				case 1: // Periods
					a_psFuncArgDef->iArgType = MSXDataArray;
					strcpy (a_psFuncArgDef->szArgName, "Periods");
					break;
				default:
					l_bRtrn = MSX_ERROR; // This will help MSXTest find errors in your code
					break;
			}
			break;

		case 7: // EMA
			
			switch (a_iNthArg)
			{
				case 0: // Data Array
					a_psFuncArgDef->iArgType = MSXDataArray;
					strcpy (a_psFuncArgDef->szArgName, "Data Array");
					break;
				case 1: // Periods
					a_psFuncArgDef->iArgType = MSXDataArray;
					strcpy (a_psFuncArgDef->szArgName, "Periods");
					break;
				default:
					l_bRtrn = MSX_ERROR; // This will help MSXTest find errors in your code
					break;
			}
			break;

		case 8: // HHV(Data Array, Periods)
	
			switch (a_iNthArg)
			{
				case 0: // Data Array
					a_psFuncArgDef->iArgType = MSXDataArray;
					strcpy (a_psFuncArgDef->szArgName, "Data Array");
					break;
				case 1: // Periods
					a_psFuncArgDef->iArgType = MSXDataArray;
					strcpy (a_psFuncArgDef->szArgName, "Periods");
					break;
				default:
					l_bRtrn = MSX_ERROR; // This will help MSXTest find errors in your code
					break;
			}
			break;

		case 9: // HHVBarsAgo(Data Array, Periods)
	
			switch (a_iNthArg)
			{
				case 0: // Data Array
					a_psFuncArgDef->iArgType = MSXDataArray;
					strcpy (a_psFuncArgDef->szArgName, "Data Array");
					break;
				case 1: // Periods
					a_psFuncArgDef->iArgType = MSXDataArray;
					strcpy (a_psFuncArgDef->szArgName, "Periods");
					break;
				default:
					l_bRtrn = MSX_ERROR; // This will help MSXTest find errors in your code
					break;
			}
			break;

		case 10: // LinearReg(Data Array, Periods)
	
			switch (a_iNthArg)
			{
				case 0: // Data Array
					a_psFuncArgDef->iArgType = MSXDataArray;
					strcpy (a_psFuncArgDef->szArgName, "Data Array");
					break;
				case 1: // Periods
					a_psFuncArgDef->iArgType = MSXDataArray;
					strcpy (a_psFuncArgDef->szArgName, "Periods");
					break;
				default:
					l_bRtrn = MSX_ERROR; // This will help MSXTest find errors in your code
					break;
			}
			break;

		case 11: // LinearRegSlope(Data Array, Periods)
	
			switch (a_iNthArg)
			{
				case 0: // Data Array
					a_psFuncArgDef->iArgType = MSXDataArray;
					strcpy (a_psFuncArgDef->szArgName, "Data Array");
					break;
				case 1: // Periods
					a_psFuncArgDef->iArgType = MSXDataArray;
					strcpy (a_psFuncArgDef->szArgName, "Periods");
					break;
				default:
					l_bRtrn = MSX_ERROR; // This will help MSXTest find errors in your code
					break;
			}
			break;

		case 12: // LLV Data Array, Periods)
	
			switch (a_iNthArg)
			{
				case 0: // Data Array
					a_psFuncArgDef->iArgType = MSXDataArray;
					strcpy (a_psFuncArgDef->szArgName, "Data Array");
					break;
				case 1: // Periods
					a_psFuncArgDef->iArgType = MSXDataArray;
					strcpy (a_psFuncArgDef->szArgName, "Periods");
					break;
				default:
					l_bRtrn = MSX_ERROR; // This will help MSXTest find errors in your code
					break;
			}
			break;
		case 13: // LLVBarsAgo(Data Array, Periods)
	
			switch (a_iNthArg)
			{
				case 0: // Data Array
					a_psFuncArgDef->iArgType = MSXDataArray;
					strcpy (a_psFuncArgDef->szArgName, "Data Array");
					break;
				case 1: // Periods
					a_psFuncArgDef->iArgType = MSXDataArray;
					strcpy (a_psFuncArgDef->szArgName, "Periods");
					break;
				default:
					l_bRtrn = MSX_ERROR; // This will help MSXTest find errors in your code
					break;
			}
			break;

		case 14: // MACD (Data Array, slowPeriods, fastPeriods)
		
			switch (a_iNthArg)
			{
				case 0: // Data Array
					a_psFuncArgDef->iArgType = MSXDataArray;
					strcpy (a_psFuncArgDef->szArgName, "Data Array");
					break;
				case 1: // Slow Periods
					a_psFuncArgDef->iArgType = MSXDataArray;
					strcpy (a_psFuncArgDef->szArgName, "Slow Periods");
					break;
				case 2: // Fast Periods
					a_psFuncArgDef->iArgType = MSXDataArray;
					strcpy (a_psFuncArgDef->szArgName, "Fast Periods");
					break;
				default:
					l_bRtrn = MSX_ERROR; // This will help MSXTest find errors in your code
					break;
			}
			break;

		case 15: // Mid
		
			switch (a_iNthArg)
			{
				case 0: 
					a_psFuncArgDef->iArgType = MSXDataArray;
					strcpy (a_psFuncArgDef->szArgName, "Data Array");
					break;
				case 1: 
					a_psFuncArgDef->iArgType = MSXDataArray;
					strcpy (a_psFuncArgDef->szArgName, "Periods");
					break;
				default:
					l_bRtrn = MSX_ERROR; // This will help MSXTest find errors in your code
					break;
			}
			break;

			
		case 16: // Mo
			
			switch (a_iNthArg)
			{
				case 0: // Data Array
					a_psFuncArgDef->iArgType = MSXDataArray;
					strcpy (a_psFuncArgDef->szArgName, "Data Array");
					break;
				case 1: // Periods
					a_psFuncArgDef->iArgType = MSXDataArray;
					strcpy (a_psFuncArgDef->szArgName, "Periods");
					break;
				default:
					l_bRtrn = MSX_ERROR; // This will help MSXTest find errors in your code
					break;
			}
			break;

		case 17: // PriceChannelHigh
			
			switch (a_iNthArg)
			{
				case 0: // Data Array
					a_psFuncArgDef->iArgType = MSXDataArray;
					strcpy (a_psFuncArgDef->szArgName, "Data Array");
					break;
				case 1: // Periods
					a_psFuncArgDef->iArgType = MSXDataArray;
					strcpy (a_psFuncArgDef->szArgName, "Periods");
					break;
				default:
					l_bRtrn = MSX_ERROR; // This will help MSXTest find errors in your code
					break;
			}
			break;

		case 18: // PriceChannelLow
			
			switch (a_iNthArg)
			{
				case 0: // Data Array
					a_psFuncArgDef->iArgType = MSXDataArray;
					strcpy (a_psFuncArgDef->szArgName, "Data Array");
					break;
				case 1: // Periods
					a_psFuncArgDef->iArgType = MSXDataArray;
					strcpy (a_psFuncArgDef->szArgName, "Periods");
					break;
				default:
					l_bRtrn = MSX_ERROR; // This will help MSXTest find errors in your code
					break;
			}
			break;

		case 19: // RSquared
			
			switch (a_iNthArg)
			{
				case 0: // Data Array
					a_psFuncArgDef->iArgType = MSXDataArray;
					strcpy (a_psFuncArgDef->szArgName, "Data Array");
					break;
				case 1: // Periods
					a_psFuncArgDef->iArgType = MSXDataArray;
					strcpy (a_psFuncArgDef->szArgName, "Periods");
					break;
				default:
					l_bRtrn = MSX_ERROR; // This will help MSXTest find errors in your code
					break;
			}
			break;

		case 20: // ROC
			
			switch (a_iNthArg)
			{
				case 0: // Data Array
					a_psFuncArgDef->iArgType = MSXDataArray;
					strcpy (a_psFuncArgDef->szArgName, "Data Array");
					break;
				case 1: // Periods
					a_psFuncArgDef->iArgType = MSXDataArray;
					strcpy (a_psFuncArgDef->szArgName, "Periods");
					break;
				case 2:
					a_psFuncArgDef->iArgType = MSXNumeric;
					strcpy (a_psFuncArgDef->szArgName, "(0 | 1)");
					break;
					/*
				case 2: // type
					a_psFuncArgDef->iArgType = MSXCustom;
					strcpy (a_psFuncArgDef->szArgName, "% | $");
					break;
					*/
				default:
					l_bRtrn = MSX_ERROR; // This will help MSXTest find errors in your code
					break;
			}
			break;

		case 21: // Ref
			
			switch (a_iNthArg)
			{
				case 0: // Data Array
					a_psFuncArgDef->iArgType = MSXDataArray;
					strcpy (a_psFuncArgDef->szArgName, "Data Array");
					break;
				case 1: // Periods
					a_psFuncArgDef->iArgType = MSXDataArray;
					strcpy (a_psFuncArgDef->szArgName, "Periods");
					break;
				default:
					l_bRtrn = MSX_ERROR; // This will help MSXTest find errors in your code
					break;
			}
			break;
		case 22: // RefWrite
			
			switch (a_iNthArg)
			{
				case 0: // Data Array
					a_psFuncArgDef->iArgType = MSXDataArray;
					strcpy (a_psFuncArgDef->szArgName, "Input Reference Array");
					break;
				case 1: 
					a_psFuncArgDef->iArgType = MSXDataArray;
					strcpy (a_psFuncArgDef->szArgName, "Assignment Array");
					break;
				case 2: 
					a_psFuncArgDef->iArgType = MSXNumeric;
					strcpy (a_psFuncArgDef->szArgName, "Static Start Pos");
					break;
				case 3: 
					a_psFuncArgDef->iArgType = MSXNumeric;
					strcpy (a_psFuncArgDef->szArgName, "Static End Pos");
					break;
				default:
					l_bRtrn = MSX_ERROR; // This will help MSXTest find errors in your code
					break;
			}
			break;

		case 23: // RMI
			
			switch (a_iNthArg)
			{
				case 0: // Data Array
					a_psFuncArgDef->iArgType = MSXDataArray;
					strcpy (a_psFuncArgDef->szArgName, "Data Array");
					break;
				case 1: // Periods
					a_psFuncArgDef->iArgType = MSXDataArray;
					strcpy (a_psFuncArgDef->szArgName, "Periods");
					break;
				case 2: // deviations
					a_psFuncArgDef->iArgType = MSXDataArray;
					strcpy (a_psFuncArgDef->szArgName, "Momentum Periods");
					break;
				default:
					l_bRtrn = MSX_ERROR; // This will help MSXTest find errors in your code
					break;
			}
			break;

		case 24: // RSI
			
			switch (a_iNthArg)
			{
				case 0: // Data Array
					a_psFuncArgDef->iArgType = MSXDataArray;
					strcpy (a_psFuncArgDef->szArgName, "Data Array");
					break;
				case 1: // Periods
					a_psFuncArgDef->iArgType = MSXDataArray;
					strcpy (a_psFuncArgDef->szArgName, "Periods");
					break;
				default:
					l_bRtrn = MSX_ERROR; // This will help MSXTest find errors in your code
					break;
			}
			break;

		case 25: // RVGI
				
			switch (a_iNthArg)
			{
				case 0: // Data Array
					a_psFuncArgDef->iArgType = MSXDataArray;
					strcpy (a_psFuncArgDef->szArgName, "Data Array");
					break;
				case 1: // Periods
					a_psFuncArgDef->iArgType = MSXDataArray;
					strcpy (a_psFuncArgDef->szArgName, "Periods");
					break;
				default:
					l_bRtrn = MSX_ERROR; // This will help MSXTest find errors in your code
					break;
			}
			break;

		case 26: // SMA
			
			switch (a_iNthArg)
			{
				case 0: // Data Array
					a_psFuncArgDef->iArgType = MSXDataArray;
					strcpy (a_psFuncArgDef->szArgName, "Data Array");
					break;
				case 1: // Periods
					a_psFuncArgDef->iArgType = MSXDataArray;
					strcpy (a_psFuncArgDef->szArgName, "Periods");
					break;
				default:
					l_bRtrn = MSX_ERROR; // This will help MSXTest find errors in your code
					break;
			}
			break;

		case 27: // Stdev
			
			switch (a_iNthArg)
			{
				case 0: // Data Array
					a_psFuncArgDef->iArgType = MSXDataArray;
					strcpy (a_psFuncArgDef->szArgName, "Data Array");
					break;
				case 1: // Periods
					a_psFuncArgDef->iArgType = MSXDataArray;
					strcpy (a_psFuncArgDef->szArgName, "Periods");
					break;
				case 2: // deviations
					a_psFuncArgDef->iArgType = MSXNumeric;
					strcpy (a_psFuncArgDef->szArgName, "deviations");
					break;
				default:
					l_bRtrn = MSX_ERROR; // This will help MSXTest find errors in your code
					break;
			}
			break;

		case 28: // Stoch (Periods)
			
			switch (a_iNthArg)
			{
				case 0: 
					a_psFuncArgDef->iArgType = MSXDataArray;
					strcpy (a_psFuncArgDef->szArgName, "Periods");
					break;
				default:
					l_bRtrn = MSX_ERROR; // This will help MSXTest find errors in your code
					break;
			}
			break;

		case 29: // Sum
			
			switch (a_iNthArg)
			{
				case 0: // Data Array
					a_psFuncArgDef->iArgType = MSXDataArray;
					strcpy (a_psFuncArgDef->szArgName, "Data Array");
					break;
				case 1: // Periods
					a_psFuncArgDef->iArgType = MSXDataArray;
					strcpy (a_psFuncArgDef->szArgName, "Periods");
					break;
				default:
					l_bRtrn = MSX_ERROR; // This will help MSXTest find errors in your code
					break;
			}
			break;

		case 30: // Tema
			
			switch (a_iNthArg)
			{
				case 0: // Data Array
					a_psFuncArgDef->iArgType = MSXDataArray;
					strcpy (a_psFuncArgDef->szArgName, "Data Array");
					break;
				case 1: // Periods
					a_psFuncArgDef->iArgType = MSXDataArray;
					strcpy (a_psFuncArgDef->szArgName, "Periods");
					break;
				default:
					l_bRtrn = MSX_ERROR; // This will help MSXTest find errors in your code
					break;
			}
			break;


		case 31: // TSF
			
			switch (a_iNthArg)
			{
				case 0: // Data Array
					a_psFuncArgDef->iArgType = MSXDataArray;
					strcpy (a_psFuncArgDef->szArgName, "Data Array");
					break;
				case 1: // Periods
					a_psFuncArgDef->iArgType = MSXDataArray;
					strcpy (a_psFuncArgDef->szArgName, "Periods");
					break;
				default:
					l_bRtrn = MSX_ERROR; // This will help MSXTest find errors in your code
					break;
			}
			break;

		case 32: // TRIX
			
			switch (a_iNthArg)
			{
				case 0: // Data Array
					a_psFuncArgDef->iArgType = MSXDataArray;
					strcpy (a_psFuncArgDef->szArgName, "Data Array");
					break;
				case 1: // Periods
					a_psFuncArgDef->iArgType = MSXDataArray;
					strcpy (a_psFuncArgDef->szArgName, "Periods");
					break;
				default:
					l_bRtrn = MSX_ERROR; // This will help MSXTest find errors in your code
					break;
			}
			break;

		case 33: // Var
			
			switch (a_iNthArg)
			{
				case 0: // Data Array
					a_psFuncArgDef->iArgType = MSXDataArray;
					strcpy (a_psFuncArgDef->szArgName, "Data Array");
					break;
				case 1: // Periods
					a_psFuncArgDef->iArgType = MSXDataArray;
					strcpy (a_psFuncArgDef->szArgName, "Periods");
					break;
				default:
					l_bRtrn = MSX_ERROR; // This will help MSXTest find errors in your code
					break;
			}
			break;

		case 34: // WMA
			
			switch (a_iNthArg)
			{
				case 0: // Data Array
					a_psFuncArgDef->iArgType = MSXDataArray;
					strcpy (a_psFuncArgDef->szArgName, "Data Array");
					break;
				case 1: // Periods
					a_psFuncArgDef->iArgType = MSXDataArray;
					strcpy (a_psFuncArgDef->szArgName, "Periods");
					break;
				default:
					l_bRtrn = MSX_ERROR; // This will help MSXTest find errors in your code
					break;
			}
			break;

		default:
			l_bRtrn = MSX_ERROR; // This will help MSXTest find errors in your code
			break;
	}

	return l_bRtrn;
}


#ifdef __cplusplus
}
#endif
